$(document).ready(function () {
  $('#payment-section').hide();
  let networkError = $('#networkError');
  let mobileNumError = $('#mobile_numberError');
  let momoError = $('#momoError');
  momoError.hide();
  let cardEmailError = $('#card_emailError');
  let cardMobileError = $('#card_mobile_numberError');
  let cardError = $('#credit-cardError');
  cardError.hide();
  let voucherCodeLyt = $('#voucher_codeLyt');
  voucherCodeLyt.hide();
  let voucherCodeError = $('#voucher_codeError');
  let displayMomoCharges = $('#displayMomoCharges');
  let displayCardCharges = $('#displayCardCharges');
  let base_url = 'https://crustsolutionsgh.com:8208';
  let checkingSubscriptionLoader = Ladda.create(
    document.querySelector('.subscription-btn')
  );
  let momo_CheckoutLoader = Ladda.create(
    document.querySelector('.momo-check-out')
  );
  let card_CheckoutLoader = Ladda.create(
    document.querySelector('.card-check-out')
  );
  checkingSubscriptionLoader.start();

  let email = sessionStorage.getItem('email');
  checkSubscription(email);

  $('#subscription-btn').on('click', function (e) {
    e.preventDefault();
    checkingSubscriptionLoader.start();
    checkSubscription(email);
  });

  $('#momo').change(function () {
    if ($(this).is(':checked')) {
      clearCardForm();
      loadMomoOptions();
    }
  });

  $('#credit-card').change(function () {
    if ($(this).is(':checked')) {
      clearMomoForm();
      loadCardOptions();
    }
  });

  $('#momo_network').change(function () {
    if (this.value === 'VOD') {
      voucherCodeLyt.show();
    } else {
      voucherCodeLyt.hide();
    }
  });

  $('#form-momo').on('submit', function (e) {
    e.preventDefault();

    momo_CheckoutLoader.start();

    let momo_network = $('#momo_network').val();
    let mobile_number = $('#mobile_number').val();
    let chargeSelected = $('input[name=momoCharges]:checked').val();
    let voucher_code = $('#voucher_code').val();

    if (
      validateMomoForm(
        momo_network,
        mobile_number,
        chargeSelected,
        voucher_code
      )
    ) {
      momoApiCall(momo_network, mobile_number, chargeSelected, voucher_code);
    } else {
      momo_CheckoutLoader.stop();
    }
  });

  $('#form-credit-card').on('submit', function (e) {
    e.preventDefault();

    card_CheckoutLoader.start();

    let cardEmail = $('#card_email').val();
    let mobile_number = $('#card_mobile_number').val();
    let chargeSelected = $('input[name=cardCharges]:checked').val();

    if (validateCardsForm(cardEmail, mobile_number, chargeSelected)) {
      cardApiCall(cardEmail, mobile_number, chargeSelected);
    } else {
      card_CheckoutLoader.stop();
    }
  });

  // check subscription
  function checkSubscription(login_email) {
    let checkTokenUrl = base_url + `/testCapFunction?imei=${login_email}`;

    $.ajax({
      dataType: 'json',
      type: 'POST',
      url: checkTokenUrl,
      secure: true,
      processData: false,
      contentType: false,
      cache: false,
      success: function (response) {
        Ladda.stopAll();

        if (response.resp_code) {
          if (response.resp_code === '555') {
            if (response.subscription_cap === '1') {
              // successful
              Swal.fire(
                'You have already subscribed to a token.',
                'Please use tokens before buying new one.',
                'info'
              );
            } else if (response.subscription_cap === '0') {
              $('#loginAlert').hide();
              $('#payment-section').show();
              Swal.fire('You do not have any subscriptions. Kindly subscribe.');
            } else {
              Swal.fire(
                'You have already subscribed to a token.',
                'Please use tokens before buying new one.',
                'info'
              );
            }
          } else if (response.resp_code === '666') {
            // you need to login to use this serve
            $('#loginAlert').hide();
            $('#payment-section').show();
            Swal.fire(`${response.resp_desc}`);
          } else if (response.resp_code === '667') {
            $('#loginAlert').hide();
            $('#payment-section').show();
            Swal.fire(
              'Your subscription has expired. Kindly renew your subscription to continue using the service.'
            );
            // Swal.fire(`${response.resp_desc}`);
          } else {
          }
        } else {
        }
      },
      error: function (err) {
        Ladda.stopAll();
      },
    });
  }

  function loadMomoOptions() {
    let getMomoChargesUrl = base_url + '/getMomoCharges?currency=GHS';

    $.ajax({
      type: 'POST',
      url: getMomoChargesUrl,
      // data: data,
      secure: true,
      success: function (response) {
        Ladda.stopAll();

        let momoChargesArr = JSON.parse(response);
        let radioButton = "<p class='text-black'>Select Frequency:</p>";

        for (let i = 0, len = momoChargesArr.length; i < len; i++) {
          let momoChargeObj = momoChargesArr[i];
          if (momoChargeObj.pay_type_id === '1') {
            let radiolabel = `${momoChargeObj.cap} Tokens for ${
              momoChargeObj.period
            } Days @ GHS ${parseFloat(momoChargeObj.cedi_val).toFixed(2)}`;
            radioButton += `<div class="form-check form-check-radio">
                                    <label class="form-check-label text-black">
                                        <input class="form-check-input" type="radio" name="momoCharges" value="${momoChargeObj.frequency_id}">
                                        <span class="form-check-sign"></span>
                                       ${radiolabel}
                                    </label>
                                </div>`;
          }
        }
        radioButton += `<div class="invalid-feedback" id="chargesError"></div>`;
        displayMomoCharges.empty();
        displayMomoCharges.append(radioButton);

        $('#credit-card-form').hide();
        $('#momo-form').show();
      },
      error: function (err) {
        Ladda.stopAll();
      },
    });
  }

  function loadCardOptions() {
    let getVisaChargesUrl = base_url + '/getVisaCharges?currency=GHS';

    $.ajax({
      dataType: 'json',
      type: 'POST',
      url: getVisaChargesUrl,
      secure: true,
      success: function (response) {
        Ladda.stopAll();

        let cardChargesArr = response;
        let radioButton = "<p class='text-black'>Select Frequency:</p>";

        for (let i = 0, len = cardChargesArr.length; i < len; i++) {
          let cardChargeObj = cardChargesArr[i];
          if (cardChargeObj.pay_type_id === '2') {
            let radiolabel = `${cardChargeObj.cap} Tokens for ${
              cardChargeObj.period
            } Days @ GHS ${parseFloat(cardChargeObj.dollar_val).toFixed(2)}`;
            radioButton += `<div class="form-check form-check-radio">
                                    <label class="form-check-label text-black">
                                        <input class="form-check-input" type="radio" name="cardCharges" value="${cardChargeObj.frequency_id}">
                                        <span class="form-check-sign"></span>
                                       ${radiolabel}
                                    </label>
                                </div>`;
          }
        }
        radioButton += `<div class="invalid-feedback" id="cardChargesError"></div>`;
        displayCardCharges.empty();
        displayCardCharges.append(radioButton);

        $('#momo-form').hide();
        $('#credit-card-form').show();
      },
      error: function (err) {
        Ladda.stopAll();
      },
    });
  }

  function validateMomoForm(
    momo_network,
    mobile_number,
    chargeSelected,
    voucher_code
  ) {
    let chargesError = $('#chargesError');
    chargesError.hide();
    networkError.hide();
    mobileNumError.hide();
    momoError.hide();
    voucherCodeError.hide();

    // if(momo_network === "" && mobile_number === "" && chargeSelected === "") {
    //     momoError.empty();
    //     momoError.append("All fields are required.");
    //     momoError.show();
    //     return false;
    // }
    if (momo_network === '') {
      networkError.empty();
      networkError.append('Please choose a mobile network.');
      networkError.show();
      return false;
    }
    if (mobile_number === '') {
      mobileNumError.empty();
      mobileNumError.append('Mobile number is required.');
      mobileNumError.show();
      return false;
    }
    if (isNaN(mobile_number)) {
      mobileNumError.empty();
      mobileNumError.append('Mobile number should be numbers only.');
      mobileNumError.show();
      return false;
    }
    if (chargeSelected === '') {
      chargesError.empty();
      chargesError.append('Please choose a frequency.');
      chargesError.show();
      return false;
    }
    if (momo_network === 'VOD') {
      if (voucher_code === '') {
        voucherCodeError.empty();
        voucherCodeError.append('Voucher code is required.');
        voucherCodeError.show();
        return false;
      }
    }

    return true;
  }

  function validateCardsForm(
    cardEmail,
    card_mobile_number,
    cardChargeSelected
  ) {
    let cardChargesError = $('#cardChargesError');
    cardEmailError.hide();
    cardMobileError.hide();

    if (cardEmail === '') {
      cardEmailError.empty();
      cardEmailError.append('Email is required.');
      cardEmailError.show();
      return false;
    }

    if (cardEmail.indexOf('@', 0) < 0) {
      cardEmailError.empty();
      cardEmailError.append('Email is not valid.');
      cardEmailError.show();
      return false;
    }

    if (cardEmail.indexOf('.', 0) < 0) {
      cardEmailError.empty();
      cardEmailError.append('Email is not valid.');
      cardEmailError.show();
      return false;
    }
    if (card_mobile_number === '') {
      cardMobileError.empty();
      cardMobileError.append('Mobile number is required.');
      cardMobileError.show();
      return false;
    }
    if (isNaN(card_mobile_number)) {
      cardMobileError.empty();
      cardMobileError.append('Mobile number should be numbers only.');
      cardMobileError.show();
      return false;
    }
    if (cardChargeSelected === '') {
      cardChargesError.empty();
      cardChargesError.append('Please choose a frequency.');
      cardChargesError.show();
      return false;
    }

    return true;
  }

  function momoApiCall(
    momo_network,
    mobile_number,
    chargeSelected,
    voucher_code
  ) {
    if (voucher_code === '') {
      voucher_code = 'N/A';
    }

    let momoApiRequestUrl =
      base_url +
      `/vin_payment_api/v2?customer_number=${mobile_number}&voucher_code=${voucher_code}&imei=${email}&radio_id=${chargeSelected}&frequency_id=1&nw=${momo_network}`;

    $.ajax({
      dataType: 'json',
      type: 'POST',
      url: momoApiRequestUrl,
      secure: true,
      success: function (response) {
        momo_CheckoutLoader.stop();
      },
      error: function (err) {
        momo_CheckoutLoader.stop();

        if (err.status === 200) {
          clearMomoForm();
          $('#momo-form').hide();
          $('#payment-section').hide();
          $('#loginAlert').show();
          Swal.fire('', 'Please confirm payment on your phone', 'success');
        } else {
          momoError.empty();
          momoError.append('An error occurred. Please try again.');
          momoError.show();
        }
      },
    });
  }

  function cardApiCall(card_email, mobile_number, cardChargeSelected) {
    let uniqid = getUniqueId();
    let cardApiRequestURL =
      base_url +
      `/post_it_gt?radio_id=${cardChargeSelected}&email=${card_email}&imei=${email}&mobile_number=${mobile_number}&uniqid=${uniqid}`;

    $.ajax({
      dataType: 'json',
      type: 'POST',
      url: cardApiRequestURL,
      secure: true,
      success: function (response) {
        card_CheckoutLoader.stop();

        if (response.resp_code === '000') {
          if (response.resp_data !== '') {
            window.location.href = response.resp_data;
          } else {
            cardError.empty();
            cardError.append('An error occurred. Please try again.');
            cardError.show();
          }
        } else {
          cardError.empty();
          cardError.append('An error occurred. Please try again.');
          cardError.show();
        }
      },
      error: function (err) {
        card_CheckoutLoader.stop();
        cardError.empty();
        cardError.append('An error occurred. Please try again.');
        cardError.show();
      },
    });
  }

  function clearMomoForm() {
    $('#form-momo').trigger('reset');
    $('#momo_network').val('').trigger('change');
  }

  function clearCardForm() {
    $('#form-credit-card').trigger('reset');
  }

  function getUniqueId() {
    let today = new Date();
    let date =
      today.getFullYear() + '' + today.getMonth() + '' + today.getDay();
    let time =
      today.getHours() +
      '' +
      today.getMinutes() +
      '' +
      today.getSeconds() +
      '' +
      today.getMilliseconds();

    return 'D2GWEB' + date + '' + time;
  }
});
